<script lang="ts">
  import ColorIcon from "./ColorIcon.svelte";
  import { Color, getCard } from "./game";

  export let cardId: CardId;
  export let faceDown: boolean = false;

  $: card = getCard(cardId);

  let colorClass: string;
  $: switch (card.color) {
    case Color.Yellow:
      colorClass = "yellow";
      break;
    case Color.Blue:
      colorClass = "blue";
      break;
    case Color.White:
      colorClass = "white";
      break;
    case Color.Green:
      colorClass = "green";
      break;
    case Color.Red:
      colorClass = "red";
      break;
    case Color.Purple:
      colorClass = "purple";
      break;
  }
</script>

<div
  class="wrapper border {!faceDown ? colorClass : ''}"
  class:face-down={faceDown}
>
  <div class="inner">
    {#if !faceDown}
      <div class="top-text">
        <div
          class="card-rank"
          class:multiplier={card.value === "x"}
          class:ten={card.value === 10}
        >
          {#if card.value === "x"}
            ×
          {:else}
            {card.value}
          {/if}
        </div>
        <div class="card-suit">
          <ColorIcon color={card.color} />
        </div>
      </div>

      <div class="center-icon">
        <ColorIcon color={card.color} />
      </div>

      <div class="bottom-text">
        <div class="card-suit">
          <ColorIcon color={card.color} />
        </div>

        <div
          class="card-rank"
          class:multiplier={card.value === "x"}
          class:ten={card.value === 10}
        >
          {#if card.value === "x"}
            ×
          {:else}
            {card.value}
          {/if}
        </div>
      </div>
    {:else}
      <div class="back-icon emoji">🧭</div>
    {/if}
  </div>
</div>

<style>
  .wrapper {
    width: 5em;
    height: 7em;
    background-color: rgb(255, 253, 250);
    box-shadow: 0.1em 0.1em 0.1em -0.02em #11111122;

    position: relative;
  }
  .yellow .inner {
    background: radial-gradient(
      circle at center,
      hsl(52, 100%, 87%),
      hsl(52, 100%, 83%)
    );
  }
  .blue .inner {
    background: radial-gradient(
      circle at center,
      hsl(218, 100%, 89%),
      hsl(218, 100%, 85%)
    );
  }
  .white .inner {
    background: radial-gradient(
      circle at center,
      hsl(0, 0%, 98%),
      hsl(0, 0%, 94%)
    );
  }
  .red .inner {
    background: radial-gradient(
      circle at center,
      hsl(0, 95%, 92%),
      hsl(0, 95%, 88%)
    );
  }
  .green .inner {
    background: radial-gradient(
      circle at center,
      hsl(81deg 63% 75%),
      hsl(81deg 63% 70%)
    );
  }
  .purple .inner {
    background: radial-gradient(
      circle at center,
      hsl(280, 75%, 88%),
      hsl(280, 75%, 84%)
    );
  }
  .face-down .inner {
    background: radial-gradient(
      circle at center,
      hsl(29, 55%, 60%),
      hsl(29, 55%, 55%)
    );
    /* background-color: #d89351; */
  }

  .inner {
    background-color: linen;
    position: relative;
    height: calc(100% - 0.5em);
    width: calc(100% - 0.5em);
    top: 0.25em;
    left: 0.25em;

    border: 0.05em solid #99999933;
    border-radius: 3.5% / 2.5%;
  }

  .top-text,
  .bottom-text {
    font-family: "Cabin";
    font-weight: 700;

    text-align: center;
  }

  .card-rank {
    font-size: 100%;
    color: white;
    filter: drop-shadow(0 0 1px #000);
  }
  .card-suit {
    font-size: 80%;
  }

  .top-text .card-rank {
    position: absolute;
    top: 8%;
    left: 13%;
    transform: translate(-50%, -50%);
  }
  .top-text .card-suit {
    position: absolute;
    top: 25%;
    left: 13%;
    transform: translate(-50%, -50%);
  }

  .bottom-text .card-suit {
    position: absolute;
    bottom: 25%;
    right: 13%;
    transform: translate(50%, 50%);
  }

  .bottom-text .card-rank {
    position: absolute;
    bottom: 8%;
    right: 13%;
    transform: translate(50%, 50%);
  }

  .card-rank.multiplier {
    font-size: 125%;
    font-weight: 400;
  }

  .center-icon {
    font-size: 175%;
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .back-icon {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) scale(2.5);
    filter: sepia(1) opacity(33%);
  }
</style>
